#include <cstdio>
#include <cstring>
using namespace std;


int vs[] = {0, 1, 5, -1, -1, 2, -1, -1, 8, -1};
int hs[] = {0, 1, -1, 3, -1, -1, -1, -1, 8, -1};

int rz[] = {0, 1, 2, 3, 5, 8};

const int N = 10;
char S[N];
int n;
char buf[N];
int l;
inline bool good()
{
    if (l != n)
        return false;
    for (int i = 0; i < l; i++)
        if (S[i] != '*' && S[i] != buf[i])
            return false;
    return true;
}

bool vert()
{
    for (int i = 0; i < l; i++)
        if (vs[buf[i] - '0'] != buf[l - 1 - i] - '0')
            return false;
    return true;
}

bool horiz()
{
    for (int i = 0; i < l; i++)
        if (hs[buf[i] - '0'] != buf[i] - '0')
            return false;
    return true;
}

int main()
{
    scanf("%d ", &n);
    for (int i = 0; i < n; i++)
    {
        char c;
        scanf("%c", &c);
        S[i] = c;
    }
    int ans = 0;
    for (int i = 0; i < 1296 * 1296; i++)
    {
        int q = i;
        int num = 0;
        for (int j = 0; j < 8; j++)
            num = 10 * num + rz[q % 6], q /= 6;
        sprintf(buf, "%d", num);
        l = strlen(buf);
        if (l != n)
            continue;
        if (!good())
            continue;
        ans += vert() || horiz();
    }
    printf("%d\n", ans);
}
