#include <cstdio>

#include "valuer.h"

using namespace NValuer;

int main()
{
    TValuer valuer(TValuer::FullScore, 60);
    valuer.Add(TestGroup(TestGroup::AllOrNothing, 1, 2, 0));
    valuer.Add(TestGroup(TestGroup::AllOrNothing, 3, 26, 30));
    valuer.Add(TestGroup(TestGroup::AllOrNothing, 27, 32, 30));
    valuer.Add(TestGroup(TestGroup::AllOrNothing, 33, 40, 40), TValuer::Offline);
    if (!valuer.Ok(100)) {
        return 43;
    }

    TEjudgeCheckResultParser parser;
    printf("%d", valuer.CalcScore(parser));

    return 0;
}
