#include <cstdio>
#include <set>
using namespace std;
#include "testlib.h"

typedef long long llong;
llong get(llong n, llong m)
{
    llong ans = 2 * n * m + n + m;
    if (m <= n)
        ans -= 2 * m - 1;
    else
        ans -= 2 * n;
    return ans;
}

set<pair<int, int> > corr, cont;

int main(int argc, char* argv[])
{
    registerTestlibCmd(argc, argv);
    llong x = inf.readInt();
    int n = ans.readInt();
    ans.readEoln();
    for (int i = 0; i < n; i++)
    {
        int a = ans.readInt(1, 1000000000);
        ans.readSpace();
        int b = ans.readInt(1, 1000000000);
        ans.readEoln();
        if (get(a, b) != x)
            quitf(_fail, "Jury thinks that %d %d is possible field but it produces value %lld instead of %lld", a, b, get(a, b), x);
        if (corr.find(make_pair(a, b)) != corr.end())
            quitf(_fail, "Jury printed same answer %d %d twice *facepalm*", a, b);
        corr.insert(make_pair(a, b));
    }
    ans.readEof();
    n = ouf.readInt();
    ouf.readEoln();
    for (int i = 0; i < n; i++)
    {
        int a = ouf.readInt(1, 1000000000);
        ouf.readSpace();
        int b = ouf.readInt(1, 1000000000);
        ouf.readEoln();
        if (get(a, b) != x)
            quitf(_wa, "Field %d %d produces value %lld instead of %lld", a, b, get(a, b), x);
        if (cont.find(make_pair(a, b)) != cont.end())
            quitf(_pe, "Pair %d %d printed twice", a, b);
        cont.insert(make_pair(a, b));
        if (corr.find(make_pair(a, b)) == corr.end())
            quitf(_fail, "Contestant found answer %d %d we didn't found! :-(", a, b);
    }
    ouf.readEof();
    if (cont.size() < corr.size())
        quitf(_wa, "Contestant found less fields than we");
    quitf(_ok, "The force is strong in this one...");
    return 0;
}
