#include <iostream>
#include <fstream>
#include <cmath>
#include <cstdlib>
#include <map>
#include <set>
#include <vector>
#include <cstring>
#include <string>
#include <algorithm>
#include <queue>

using namespace std;

const int nmax = 1e5;
const int inf = 1e9;

vector <int> g[nmax];
vector <int> w[nmax];


int t[nmax];
int n,m;

struct node
{
	int value;
	node* next;
};

node A[nmax * 10];
int P = 0;
node* q[2];


int bfs(int v, int u)
{
	P = 0;
	for (int i = 0; i < n; i ++)
		t[i] = inf;
	t[v] = 0;
	q[0] = &A[P ++];
	q[0] -> next = 0;
	q[0] -> value = v;
	int cur_dist = 0;
	while (q[0] || q[1])
	{
		while (q[0])
		{
			int v = q[0]->value; q[0] = q[0]->next;
			for (int i = 0; i < g[v].size(); i ++)
			{
				int u = g[v][i];
				int c = w[v][i];
				if (t[u] > t[v] + c)
				{
					t[u] = t[v] + c;
//					q[c].push(u);
					A[P].next = q[c];
					A[P].value = u;
					q[c] = &A[P];
					P ++;
				}
			}
		}
		q[0] = q[1];
		q[1] = NULL;
	}
	return (t[u] > n ? -1 : t[u]);
}

int main()	
{
	scanf("%d%d", &n, &m);
	for (int i = 0; i < m; i ++)
	{
		int x,y;
		scanf("%d%d",&x,&y);
		x --; y --;
		g[x].push_back(y);
		w[x].push_back(0);
		g[y].push_back(x);
		w[y].push_back(1);
	}
	int k;
	scanf("%d",&k);
	for (int i = 0; i < k; i ++)
	{
		int u,v;
		scanf("%d%d", &u, &v);
		u --; v --;
		printf("%d\n", bfs(u, v));
	}
	return 0;
}
